# Custom
Feature: Custom Logic

  Background: Open main list form
    Given I open the main page with username "admin" and password "admin"

  Scenario: 001 - Check the default values of a document
    And I open form for new entity with type "DOCUMENT" and name "Sell"
    And I add new row to table "Products"
    And field "Comment" must be "Test comment"
    And field "Address" must be "1000, Kyiv"
    And I close all open tabs
  Scenario: 002 - Check for correct price calculations
    And I open form for new entity with type "DOCUMENT" and name "Sell"
    And I add new row to table "Products"
    And provide value "3.00" to column "Price"
    And column "Amount" must be "0.00"
    And provide value "5" to column "Quantity"
    And column "Amount" must be "15.00"
    And provide value "3.15" to column "Price"
    And column "Amount" must be "15.75"
    And provide value "0.00" to column "Price"
    And column "Amount" must be "0.00"
    And I close all open tabs
  Scenario: 002a - Correct price calculations for multiple rows
    And I open form for new entity with type "DOCUMENT" and name "Sell"
    And I add new row to table "Products"
    And I choose row in table "Products" where value in column "#" is "2"
    And column "Price" must be "0.00"
    And column "Quantity" must be "0"
    And column "Amount" must be "0.00"
    And field "Total amount" must be "10.00"
    And provide value "3.00" to column "Price"
    And column "Amount" must be "0.00"
    And field "Total amount" must be "10.00"
    And provide value "5" to column "Quantity"
    And column "Amount" must be "15.00"
    And field "Total amount" must be "25.00"
    And I add new row to table "Products"
    And field "Total amount" must be "25.00"
    And I choose row in table "Products" where value in column "#" is "3"
    And provide value "4" to column "Quantity"
    And column "Amount" must be "0.00"
    And field "Total amount" must be "25.00"
    And provide value "15.00" to column "Price"
    And column "Amount" must be "60.00"
    And field "Total amount" must be "85.00"
    And I choose row in table "Products" where value in column "#" is "2"
    And provide value "0.00" to column "Price"
    And column "Amount" must be "0.00"
    And field "Total amount" must be "70.00"
    And I choose row in table "Products" where value in column "#" is "3"
    And provide value "3" to column "Quantity"
    And column "Amount" must be "45.00"
    And field "Total amount" must be "55.00"
    And provide value "0.00" to column "Price"
    And column "Amount" must be "0.00"
    And field "Total amount" must be "10.00"
    And I close all open tabs
  Scenario: 003 - Document saving and updating
    And I open form for new entity with type "DOCUMENT" and name "Sell"
    And I add new row to table "Products"
    And provide value "2.00" to column "Price"
    And provide value "5" to column "Quantity"
    And column "Amount" must be "10.00"
    And click button with text "Save"
    And I open list form of entity with type "DOCUMENT" and name "Sell"
    And I choose row in table of entity list with type "DOCUMENT" and name "Sell" where value in column "Key" is "0000000001"
    And value in current row in column "Products" must be "Items: 2"
    And value in current row in column "Total Amount" must be "20.00"
    And value in current row in column "Comment" must be "Test comment"
    And value in current row in column "Address" must be "1000, Kyiv"
    And I open form for entity with type "DOCUMENT", name "Sell", and key "0000000001"
    And I choose row in table "Products" where value in column "#" is "2"
    And I remove current row from table "Products"
    And click button with text "Save"
    And I open list form of entity with type "DOCUMENT" and name "Sell"
    And I choose row in table of entity list with type "DOCUMENT" and name "Sell" where value in column "Key" is "0000000001"
    And value in current row in column "Products" must be "Items: 1"
    And value in current row in column "Total Amount" must be "10.00"
    And value in current row in column "Comment" must be "Test comment"
    And value in current row in column "Address" must be "1000, Kyiv"
    And I open form for entity with type "DOCUMENT", name "Sell", and key "0000000001"
    And I add new row to table "Products"
    And provide value "1.50" to column "Price"
    And provide value "5" to column "Quantity"
    And column "Amount" must be "7.50"
    And click button with text "Save"
    And I open list form of entity with type "DOCUMENT" and name "Sell"
    And I choose row in table of entity list with type "DOCUMENT" and name "Sell" where value in column "Key" is "0000000001"
    And value in current row in column "Products" must be "Items: 2"
    And value in current row in column "Total Amount" must be "17.50"
    And value in current row in column "Comment" must be "Test comment"
    And value in current row in column "Address" must be "1000, Kyiv"
    And I close all open tabs
